/*
CIFFOLD 0.5.1 Pre-Release
by Kostadin Mitev, Georgi Todorov and Herbert J. Bernstein

Copyright (C) Kostadin Mitev 2005

Work funded in part by the International Union of Crystallography under
a grant to Dowling College.

This software is covered by the GNU General Public License 
<see COPYING>.

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

 */

#ifndef READFILE_H 
#define READFILE_H
#define isreserved ( (!strncasecmp((curLine + pos), "data_", 5))||(!strncasecmp((curLine + pos), "save_", 5))|| (!strncasecmp((curLine + pos), "global_", 5)) )
#include <set>
#include <vector>
#include <string>
#include <fstream>
#include <unistd.h>
using namespace std;

#ifdef READFILE
vector<bool> FORMATTEXT;
vector<bool> FOLDEDTEXT;
vector<bool> FOLDEDLAST;
#else
extern vector<bool> FORMATTEXT;
extern vector<bool> FOLDEDTEXT;
extern vector<bool> FOLDEDLAST;
#endif

typedef struct{
	unsigned long int ntags;
	unsigned long int ndata;
	bool format;
        unsigned long int *colsize;
} loop;


using namespace std;
int rmtblanks(char *curStr);

class ReadFile
{
	private:
		vector<loop>  lpinfo;
		unsigned int index;
		loop loopNull;
	public:
	ReadFile ()
	{
		 loopNull.ntags = 0;
	         loopNull.ndata = 0;
		 loopNull.format = false;
	}
	char* read(char *, int, int, int );
	int findName(char *, ofstream &, int& , int , char *);
	loop* getLoop(int);
	loop getLoop();
	int iterate(char *&, int&, char, ofstream &, istream &, int&, int);
	void ReadFile::printErr(FILE *, int, int);
	void printErr();
	int rmLBl(char *, int&, ofstream &);
	void lpinfoInitColsize(int);	
	char * getMapfilename();
	string convertToStr(int);
	~ReadFile();
};
#endif
